tests: move sanitization and "Bournification" in the generic test lib
[platform/upstream/automake.git] / t / ax / test-lib.sh
1 # -*- shell-script -*-
2 #
3 # Copyright (C) 1996-2012 Free Software Foundation, Inc.
4 #
5 # This program is free software; you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation; either version 2, or (at your option)
8 # any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
17
18 ########################################################
19 ###  IMPORTANT NOTE: keep this file 'set -e' clean.  ###
20 ########################################################
21
22 # CDPATH is evil if used in non-interactive scripts (and even more
23 # evil if exported in the environment).
24 CDPATH=; unset CDPATH
25
26 # Be more Bourne compatible.
27 # (Snippet inspired to configure's initialization in Autoconf 2.64)
28 DUALCASE=1; export DUALCASE # for MKS sh
29 if test -n "${ZSH_VERSION+set}" && (emulate sh) >/dev/null 2>&1; then
30   emulate sh
31   NULLCMD=:
32   setopt NO_GLOB_SUBST
33   # If Zsh is not started directly in POSIX-compatibility mode, it has some
34   # incompatibilities in the handling of $0 that conflict with our usage;
35   # i.e., $0 inside a file sourced with the '.' builtin is temporarily set
36   # to the name of the sourced file.  Work around that.
37   # Note that a bug in some versions of Zsh prevents us from resetting $0
38   # in a sourced script, so the use of $argv0.  For more info see:
39   #   <http://www.zsh.org/mla/workers/2009/msg01140.html>
40   # The apparently useless 'eval' here is needed by at least dash 0.5.2,
41   # to prevent it from bailing out with an error like:
42   #   "Syntax error: Bad substitution".
43   eval 'argv0=${functrace[-1]%:*}' && test -f "$argv0" || {
44     echo "Cannot determine the path of running test script." >&2
45     echo "Your Zsh (version $ZSH_VERSION) is probably too old." >&2
46     exit 99
47   }
48 else
49   argv0=$0
50   # Avoid command substitution failure, for it might cause problems with
51   # "set -e" on some shells.
52   case `(set -o) 2>/dev/null || :` in *posix*) set -o posix;; esac
53 fi
54
55 # A single whitespace character.
56 sp=' '
57 # A tabulation character.
58 tab='   '
59 # A newline character.
60 nl='
61 '
62
63 # As autoconf-generated configure scripts do, ensure that IFS
64 # is defined initially, so that saving and restoring $IFS works.
65 IFS=$sp$tab$nl
66
67 # The name of the current test (without the '.sh' or '.tap' suffix).
68 me=${argv0##*/} # Strip all directory components.
69 case $me in     # Strip test suffix.
70    *.tap) me=${me%.tap};;
71     *.sh) me=${me%.sh} ;;
72  esac
73
74 # Source extra package-specific configuration.
75 . test-defs.sh
76 # And fail hard if something went wrong.
77 test $? -eq 0 || exit 99
78
79 # We use a trap below for cleanup.  This requires us to go through
80 # hoops to get the right exit status transported through the signal.
81 # Turn off errexit here so that we don't trip the bug with OSF1/Tru64
82 # sh inside this function (FIXME: is this still relevant now that we
83 # require a POSIX shell?).
84 _am_exit ()
85 {
86   set +e
87   # See comments in the exit trap for the reason we do this.
88   test 77 = $1 && am__test_skipped=yes
89   # Spurious escaping to ensure we do not call our 'exit' alias.
90   (\exit $1); \exit $1
91 }
92 # Avoid interferences from the environment
93 am__test_skipped=no
94 # This alias must actually be placed before any use if 'exit' -- even
95 # just inside a function definition.  Weird, but real.
96 alias exit=_am_exit
97
98 ## ------------------------------------ ##
99 ##  General testsuite shell functions.  ##
100 ## ------------------------------------ ##
101
102 # Print warnings (e.g., about skipped and failed tests) to this file
103 # number.  Override by putting, say:
104 #   AM_TESTS_ENVIRONMENT = stderr_fileno_=9; export stderr_fileno_;
105 #   AM_TESTS_FD_REDIRECT = 9>&2
106 # in your Makefile.am.
107 # This is useful when using automake's parallel tests mode, to print the
108 # reason for skip/failure to console, rather than to the *.log files.
109 : ${stderr_fileno_=2}
110
111 # Helper functions used by "plain" tests of the Automake testsuite
112 # (i.e., tests that don't use any test protocol).
113 # TAP tests will override these functions with their TAP-enhanced
114 # equivalents later  (see sourcing of 'tap-functions.sh' below).
115 # These are copied from Gnulib's 'tests/init.sh'.
116 warn_ () { echo "$@" 1>&$stderr_fileno_; }
117 fail_ () { warn_ "$me: failed test: $@"; exit 1; }
118 skip_ () { warn_ "$me: skipped test: $@"; exit 77; }
119 fatal_ () { warn_ "$me: hard error: $@"; exit 99; }
120 framework_failure_ () { warn_ "$me: set-up failure: $@"; exit 99; }
121 # For compatibility with TAP functions.
122 skip_all_ () { skip_ "$@"; }
123
124 if test $am_using_tap = yes; then
125   . tap-functions.sh
126 fi
127
128 ## ---------------------------- ##
129 ##  Auxiliary shell functions.  ##
130 ## ---------------------------- ##
131
132 # Tell whether we should keep the test directories around, even in
133 # case of success.  By default, we don't.
134 am_keeping_testdirs ()
135 {
136   case $keep_testdirs in
137      ""|n|no|NO) return 1;;
138               *) return 0;;
139   esac
140 }
141
142 # seq_ - print a sequence of numbers
143 # ----------------------------------
144 # This function simulates GNU seq(1) portably.  Valid usages:
145 #  - seq LAST
146 #  - seq FIRST LAST
147 #  - seq FIRST INCREMENT LAST
148 seq_ ()
149 {
150   case $# in
151     0) fatal_ "seq_: missing argument";;
152     1) seq_first=1  seq_incr=1  seq_last=$1;;
153     2) seq_first=$1 seq_incr=1  seq_last=$2;;
154     3) seq_first=$1 seq_incr=$2 seq_last=$3;;
155     *) fatal_ "seq_: too many arguments";;
156   esac
157   i=$seq_first
158   while test $i -le $seq_last; do
159     echo $i
160     i=$(($i + $seq_incr))
161   done
162 }
163
164 # rm_rf_ [FILES OR DIRECTORIES ...]
165 # ---------------------------------
166 # Recursively remove the given files or directory, also handling the case
167 # of non-writable subdirectories.
168 rm_rf_ ()
169 {
170   test $# -gt 0 || return 0
171   # Ignore failures in find, we are only interested in failures of the
172   # final rm.
173   find "$@" -type d ! -perm -700 -exec chmod u+rwx {} \; || :
174   rm -rf "$@"
175 }
176
177 commented_sed_unindent_prog='
178   /^$/b                    # Nothing to do for empty lines.
179   x                        # Get x<indent> into pattern space.
180   /^$/{                    # No prior x<indent>, go prepare it.
181     g                      # Copy this 1st non-blank line into pattern space.
182     s/^\(['"$tab"' ]*\).*/x\1/   # Prepare x<indent> in pattern space.
183   }                        # Now: x<indent> in pattern and <line> in hold.
184   G                        # Build x<indent>\n<line> in pattern space, and
185   h                        # duplicate it into hold space.
186   s/\n.*$//                # Restore x<indent> in pattern space, and
187   x                        # exchange with the above duplicate in hold space.
188   s/^x\(.*\)\n\1//         # Remove leading <indent> from <line>.
189   s/^x.*\n//               # Restore <line> when there is no leading <indent>.
190 '
191
192 # unindent [input files...]
193 # -------------------------
194 # Remove the "proper" amount of leading whitespace from the given files,
195 # and output the result on stdout.  That amount is determined by looking
196 # at the leading whitespace of the first non-blank line in the input
197 # files.  If no input file is specified, standard input is implied.
198 unindent ()
199 {
200   if test x"$sed_unindent_prog" = x; then
201     sed_unindent_prog=$(printf '%s\n' "$commented_sed_unindent_prog" \
202                           | sed -e "s/  *# .*//")
203   fi
204   sed "$sed_unindent_prog" ${1+"$@"}
205 }
206 sed_unindent_prog="" # Avoid interferences from the environment.
207
208 ## ---------------------------------------------------------------- ##
209 ##  Create and set up of the temporary directory used by the test.  ##
210 ##  Set up of the exit trap for cleanup of said directory.          ##
211 ## ---------------------------------------------------------------- ##
212
213 # Set up the exit trap.
214 am_exit_trap ()
215 {
216   exit_status=$1
217   set +e
218   cd "$am_top_builddir"
219   if test $am_using_tap = yes; then
220     if test "$planned_" = later && test $exit_status -eq 0; then
221       plan_ "now"
222     fi
223     test $exit_status -eq 0 && test $tap_pass_count_ -eq $tap_count_ \
224       || keep_testdirs=yes
225   else
226     # This is to ensure that a test script does give a SKIP outcome just
227     # because a command in it happens to exit with status 77.  This
228     # behaviour, while from time to time useful to developers, is not
229     # meant to be enabled by default, as it could cause spurious failures
230     # in the wild.  Thus it will be enabled only when the variable
231     # "am_explicit_skips" is set to a "true" value.
232     case $am_explicit_skips in
233       [yY]|[yY]es|1)
234         if test $exit_status -eq 77 && test $am__test_skipped != yes; then
235           echo "$me: implicit skip turned into failure"
236           exit_status=78
237         fi;;
238     esac
239     test $exit_status -eq 0 || keep_testdirs=yes
240   fi
241   am_keeping_testdirs || rm_rf_ $am_test_subdir
242   set +x
243   echo "$me: exit $exit_status"
244   # Spurious escaping to ensure we do not call our "exit" alias.
245   \exit $exit_status
246 }
247
248 am_set_exit_traps ()
249 {
250   trap 'am_exit_trap $?' 0
251   trap "fatal_ 'caught signal SIGHUP'" 1
252   trap "fatal_ 'caught signal SIGINT'" 2
253   trap "fatal_ 'caught signal SIGTERM'" 15
254   # Various shells seems to just ignore SIGQUIT under some circumstances,
255   # even if the signal is not blocked; however, if the signal it trapped,
256   # the trap gets correctly executed.  So we also trap SIGQUIT.
257   # Here is a list of some shells that have been verified to exhibit the
258   # problematic behavior with SIGQUIT:
259   #  - zsh 4.3.12 on Debian GNU/Linux
260   #  - /bin/ksh and /usr/xpg4/bin/sh on Solaris 10
261   #  - Bash 3.2.51 on Solaris 10 and bash 4.1.5 on Debian GNU/Linux
262   #  - AT&T ksh on Debian Gnu/Linux (deb package ksh, version 93u-1)
263   # OTOH, at least these shells that do *not* exhibit that behaviour:
264   #  - modern version of the Almquist Shell (at least 0.5.5.1), on
265   #    both Solaris and GNU/Linux
266   #  - public domain Korn Shell, version 5.2.14, on Debian GNU/Linux
267   trap "fatal_ 'caught signal SIGQUIT'" 3
268   # Ignore further SIGPIPE in the trap code.  This is required to avoid
269   # a very weird issue with some shells, at least when the execution of
270   # the automake testsuite is driven by the 'prove' utility: if prove
271   # (or the make process that has spawned it) gets interrupted with
272   # Ctrl-C, the shell might go in a loop, continually getting a SIGPIPE,
273   # sometimes finally dumping core, other times hanging indefinitely.
274   # See also Test::Harness bug [rt.cpan.org #70855], archived at
275   # <https://rt.cpan.org/Ticket/Display.html?id=70855>
276   trap "trap '' 13; fatal_ 'caught signal SIGPIPE'" 13
277 }
278
279 am_test_setup ()
280 {
281   process_requirements $required
282   am_set_exit_traps
283   # Create and populate the temporary directory, if required.
284   if test x"$am_create_testdir" = x"no"; then
285     am_test_subdir=
286   else
287     am_setup_testdir
288   fi
289   am_extra_info
290   set -x
291   pwd
292 }